<?php
 class Log { const I_GENERAL = 1; const I_DETAIL = 2; const I_ALL = 3; private static $oObj = null; private $sLogFileSpec; private $fhLog=null; private function __construct($sTaskName=null, $sLogDir=null) { date_default_timezone_set('America/Toronto'); $this->sLogFileSpec = (is_null($sLogDir) ? "" : preg_replace("`[/\\\\]+$`", "/", $sLogDir . "/")) . date("Y-m-d_H-i-s") . (is_null($sTaskName) ? "" : '_' . $sTaskName) . '.log'; $this->fhLog = fopen($this->sLogFileSpec, 'w'); if (!$this->fhLog) { trigger_error("Cannot open the log file for write access: " . $this->sLogFileSpec, E_USER_ERROR); } } public static function getObj($sTaskName=null, $sLogDir=null) { if (is_null(self::$oObj)) { self::$oObj = new Log($sTaskName, $sLogDir); } return self::$oObj; } static public function makeHtmlHead(&$aHtmlHead) { $aHtmlHead[get_class()] = <<<endHead
<style type='text/css'>
p.log_statusMsg {
    margin-bottom: 0;
    font-family: monospace;
    margin-left: 5em;
    text-indent: -5em;
}
p.log_statusMsgIndent {
    margin-top: 0.25em;
    margin-bottom: 0.25em;
    font-family: monospace;
    margin-left: 7em;
    text-indent: -7em;
}
</style>
endHead
. "\n"; } public function getLogFileSpec() { return $this->sLogFileSpec; } public function genLine($sLine, $iFlag=self::I_ALL) { $sOut = strftime("%H:%M:%S ") . $sLine; if ($iFlag & self::I_GENERAL) { if (preg_match('/\t/', $sOut)) { print("<p class='log_statusMsgIndent'>" . preg_replace('/\t/', '&nbsp;&nbsp;&nbsp;&nbsp;', htmlentities($sOut)) . "</p>"); } else { print("<p class='log_statusMsg'>" . htmlentities($sOut) . "</p>"); } } if (($iFlag & self::I_DETAIL) && !is_null($this->fhLog)) { fwrite($this->fhLog, $sOut . "\n"); } } public function addBlk($sBlk, $iFlag=self::I_ALL) { if ($iFlag & self::I_GENERAL) { print($sBlk); } if (($iFlag & self::I_DETAIL) && !is_null($this->fhLog)) { fwrite($this->fhLog, $sBlk . "\n"); } } public function __destruct() { if (!is_null($this->fhLog)) { fclose($this->fhLog); } } } ?>
