<?php
 class MefMetadata { const S_FILE_ID = 'fileId'; const S_TITLE = 'title'; const S_THUMBNAILS = 'thumbnails'; const S_ZIP_DOWNLOAD = 'zipDownload'; const S_REF_SYS_ID = 'refSysId'; const S_BOUNDING_BOX = 'boundingBox'; const S_SPTL_REP_TYPE_CODE ='sptlRepTypeCode'; const S_SPTL_REP_INFO = 'sptlRepInfo'; private $sMetadata = null; function __construct($sMetadataPath, $aDirLevel, $sTmpltSpec, PlchldrDb $oPlchldrDb) { $fhTmplt = fopen($sTmpltSpec, 'r'); $sTmplt = fread($fhTmplt, filesize($sTmpltSpec)); $this->sMetadata = $oPlchldrDb->expTmplt($sMetadataPath, $aDirLevel, $sTmplt); fclose($fhTmplt); } public function makeXml($aFieldVal) { $oMetadataDom = new DOMDocument(); if ($oMetadataDom->loadXML($this->sMetadata)) { $aXsl = array(); foreach ($aFieldVal as $sName => $sEscXml) { switch ($sName) { case self::S_FILE_ID: $aXsl[] = "<xsl:template match=\"gmd:MD_Metadata/gmd:fileIdentifier\">" . $sEscXml . "</xsl:template>"; break; case self::S_TITLE: break; case self::S_THUMBNAILS: $aXsl[] = "<xsl:template match=\"/gmd:MD_Metadata/gmd:identificationInfo/gmd:MD_DataIdentification/gmd:graphicOverview\" />" . "<xsl:template match=\"/gmd:MD_Metadata/gmd:identificationInfo/gmd:MD_DataIdentification/gmd:resourceMaintenance\">
                             <xsl:copy>
                               <xsl:apply-templates match=\"@*|node()\"/>
                             </xsl:copy>" . $sEscXml . "</xsl:template>"; break; case self::S_BOUNDING_BOX: $aXsl[] = '<xsl:template match="/gmd:MD_Metadata/gmd:identificationInfo/gmd:MD_DataIdentification/gmd:extent/gmd:EX_Extent/gmd:geographicElement/gmd:EX_GeographicBoundingBox">' . $sEscXml . '</xsl:template>'; break; case self::S_SPTL_REP_INFO: $aXsl[] = '<xsl:template match="/gmd:MD_Metadata/gmd:spatialRepresentationInfo">' . $sEscXml . '</xsl:template>'; break; case self::S_SPTL_REP_TYPE_CODE: $aXsl[] = '<xsl:template match="/gmd:MD_Metadata/gmd:identificationInfo/gmd:MD_DataIdentification/gmd:spatialRepresentationType">' . $sEscXml . '</xsl:template>'; break; case self::S_REF_SYS_ID: $aXsl[] = '<xsl:template match="/gmd:MD_Metadata/gmd:referenceSystemInfo/gmd:MD_ReferenceSystem/gmd:referenceSystemIdentifier/gmd:RS_Identifier">' . $sEscXml . '</xsl:template>'; break; case self::S_ZIP_DOWNLOAD: $aXsl[] = '<xsl:template match="/gmd:MD_Metadata/gmd:distributionInfo/gmd:MD_Distribution/gmd:transferOptions/gmd:MD_DigitalTransferOptions">' . $sEscXml . '</xsl:template>'; break; default: trigger_error("Unrecognized field name - $sName", E_USER_ERROR); } } $oChangeXslDom = new DOMDocument(); $sXslt = $this->makeXsl($aXsl); if ($oChangeXslDom->loadXML($sXslt)) { $oXslt = new XSLTProcessor(); $oXslt->importStylesheet($oChangeXslDom); } else { print('<p>Problem in loading the following XSLT stylesheet:<p><pre>' . htmlentities($sXslt) . '</pre>'); trigger_error("Problem with loading XML.", E_USER_ERROR); } } else { print('<p>Problem in loading the following expanded XML template:<p><pre>' . htmlentities($this->sMetadata) . '</pre>'); trigger_error("Problem with loading XML.", E_USER_ERROR); } return $oXslt->transformToXML($oMetadataDom); } private function makeXsl($aXsl) { return '<?xml version="1.0" encoding="UTF-8"?>
             <!DOCTYPE stylesheet [
               <!ENTITY amp  "&#38;" ><!-- small n, tilde -->
             ]>
             <xsl:stylesheet version="1.0"
                             xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                             xmlns:gmd="http://www.isotc211.org/2005/gmd"
                             xmlns:csw="http://www.opengis.net/cat/csw/2.0.2"
                             xmlns:gco="http://www.isotc211.org/2005/gco"
                             xmlns:geonet="http://www.fao.org/geonetwork"
             >
               <xsl:output encoding="UTF-8" indent="yes"/>' . '<xsl:template match="@*|node()">
                 <xsl:copy>
                   <xsl:apply-templates select="@*|node()"/>
                 </xsl:copy>
               </xsl:template>' . join("\n", $aXsl) . '</xsl:stylesheet>'; } } ?>
