<?php
 ini_set("display_errors", 1); ini_set('error_reporting', E_ALL); require_once('../lib/class.Inc.php'); Inc::setIncPaths(); require_once($GLOBALS['sAppDir'] . "reg/class.Reg.php"); $oReg = new Reg(true); ?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>NAP Register Items</title>

<!-- Stop IE from screwing up css rules when compatibility mode is enabled. -->
<!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=9; IE=8; IE=7; IE=5" ><![endif]-->

<style type="text/css">
* {
    font-family: verdana;
}
ol.collapsible {
    margin-top: 1em;
}

  ol.collapsible li {
      /* Indent the list further to have enough room for numbering more
       * than a hundred items.
       */
      margin-left: 1em;
      padding-top: 0.5em;
      padding-bottom: 0.5em;
      padding-left: 1.5em;
      padding-right: 0.5em;
      text-indent: -1.5em;
      cursor: default;
  }

  ol.collapsible li.expanded,
  ol.collapsible li.collapsed {
      cursor: pointer;
  }

  ol.collapsible li.expanded:before,
  ol.collapsible li.collapsed:before {
      display: inline;
      text-align: center;
      font-weight: bold;
      font-size: 150%;
      font-family: consolas, monospace;
      color: blue;
  }

  ol.collapsible li.expanded:before {
      content: '- ';
  }

  ol.collapsible li.collapsed:before {
      content: '+ ';
  }

  ol.collapsible li.expanded:hover,
  ol.collapsible li.collapsed:hover,
  ol.collapsible li.expanded:hover span.classTitle,
  ol.collapsible li.collapsed:hover span.classTitle,
  ol.collapsible li.expanded:hover span.classHeader,
  ol.collapsible li.collapsed:hover span.classHeader {
      background-color: #e5ffe5;
  }

    ol.collapsible li.expanded:hover *,
    ol.collapsible li.collapsed:hover * {
        background-color: #ffffcc;
    }
  ol.collapsible div.itemDetail {
      margin-left: 1em;
      text-indent: 0em;
  }
  ol.collapsible span.classHeader,
  ol.collapsible span.detailHeader {
      font-weight: bold;
  }
</style>
<script type="text/javascript" src="<?= $GLOBALS['sLibRelUrl'] ?>jquery-1.7.min.js"></script>
<script type='text/javascript'>
(function($) {
    $.fn.toggleExpandCollapse = function(event) {
        event.stopPropagation();
        if (this.find('ol').length > 0) {
            event.preventDefault();
            this.toggleClass('collapsed').toggleClass('expanded').
              find('> ol').slideToggle('normal');
        }
        return this;
    }
})($);

function prependToggleAllLinks() {
    var container = $('<div>').attr('class', 'expand_or_collapse_all');
    container.append(
        $("<a>").attr('href', "#").
        html('Expand all').click(handleExpandAll)
    ).
      append(' | ').
      append(
        $('<a>').attr('href', '#').
          html('Collapse all').click(handleCollapseAll)
      );
    $('ol.collapsible').prepend(container);
}

function handleExpandAll(event) {
    $('ol.collapsible li.collapsed').toggleExpandCollapse(event);
}

function handleCollapseAll(event) {
    $('ol.collapsible li.expanded').toggleExpandCollapse(event);
}

function initializeCollapsibleList() {
    $('ol.collapsible li').click(function(event) {
        $(this).toggleExpandCollapse(event);
    });
    $('ol.collapsible li:not(.expanded) > ol').hide();
    $('ol.collapsible li ol').
      parent(':not(.expanded)').
      addClass('collapsed');
}

$(document).ready(function() {
    initializeCollapsibleList();
    prependToggleAllLinks();
})
</script>
</head>
<body>
<!--<?= $GLOBALS['spc'] ?>-->
<h1>NAP Register Items</h1>
<?php
print("<ol class='collapsible'>"); ksort(Reg::$aClass); foreach (Reg::$aClass as $sClassName => $aInfo) { list($sDef, $sDesc, $sFrDef, $sFrDesc) = getDefDesc(0, $aInfo); $iItemCount = count($aInfo['aItem']) - 1; print("<li>" . "<span class='classTitle' title='Class Name'>$sClassName</span> " . "(<span class='classTitle' title='Class Id'>{$aInfo['sClassId']}</span>)" . (($iItemCount > 0) ? " [$iItemCount sub-item" . (($iItemCount> 1) ? "s" : "") . "]" : "") . ((is_null($sDef) && is_null($sDesc) && is_null($sFrDef) && is_null($sFrDesc)) ? "" : ((trim($sDef) == "") ? "" : "<br /><br /><span class='classHeader'>Definition:</span> $sDef") . ((trim($sFrDef) == "") ? "" : "<br /><br /><span class='classHeader'>Definition (French):</span> $sFrDef") . ((trim($sDesc) == "") ? "" : "<br /><br /><span class='classHeader'>Description:</span> $sDesc") . ((trim($sFrDesc) == "") ? "" : "<br /><br /><span class='classHeader'>Description (French):</span> $sFrDesc"))); if ($iItemCount > 0) { print("<ol>"); for ($i=1; $i<count($aInfo['aItem']); $i++) { list($sDef, $sDesc, $sFrDef, $sFrDesc) = getDefDesc($i, $aInfo); $sFrName = (array_key_exists('sFrName', $aInfo['aItem'][$i]) ? "<span title='Value in French'>&laquo;" . $aInfo['aItem'][$i]['sFrName'] . "&raquo;</span>" : null); if (trim($sFrName) == '') { $sFrName = "*** MISSING ***"; } print("<li>" . "<span title='Value in English'>{$aInfo['aItem'][$i]['sName']}</span>" . " $sFrName " . "(<span title='Value Id'>{$aInfo['aItem'][$i]['sId']}</span>)" . ((is_null($sDef) && is_null($sDesc) && is_null($sFrDef) && is_null($sFrDesc)) ? "" : "<div class='itemDetail'> " . ((trim($sDef) == "") ? "" : "<p><span class='detailHeader'>Definition:</span> $sDef</p> ") . ((trim($sFrDef) == "") ? "" : "<p><span class='detailHeader'>Definition (French):</span> $sFrDef</p> ") . ((trim($sDesc) == "") ? "" : "<p><span class='detailHeader'>Description:</span> " . $sDesc . "</p>") . ((trim($sFrDesc) == "") ? "" : "<p><span class='detailHeader'>Description (French):</span> " . $sFrDesc . "</p>") . "</div>") . "</li>"); } print( "</ol>"); } print("</li>"); } print("</ol>"); function getDefDesc($iItemIdx, &$aInfo) { $sDef = (array_key_exists('sDef', $aInfo['aItem'][$iItemIdx]) ? $aInfo['aItem'][$iItemIdx]['sDef'] : null); $sDesc = (array_key_exists('sDesc', $aInfo['aItem'][$iItemIdx]) ? $aInfo['aItem'][$iItemIdx]['sDesc'] : null); $sFrDef = (array_key_exists('sFrDef', $aInfo['aItem'][$iItemIdx]) ? $aInfo['aItem'][$iItemIdx]['sFrDef'] : null); $sFrDesc = (array_key_exists('sFrDesc', $aInfo['aItem'][$iItemIdx]) ? $aInfo['aItem'][$iItemIdx]['sFrDesc'] : null); list($sDef, $sFrDef) = chkCounterpart($sDef, $sFrDef); list($sDesc, $sFrDesc) = chkCounterpart($sDesc, $sFrDesc); return array($sDef, $sDesc, $sFrDef, $sFrDesc); } function chkCounterpart($sEn, $sFr) { if (trim($sEn . $sFr) != '') { if (trim($sEn) == '') { $sEn = "*** MISSING ***"; } if (trim($sFr) == '') { $sFr = "*** MISSING ***"; } } return array($sEn, $sFr); } ?>
</body>
</html>
