<?php
 set_time_limit(0); ini_set('max_execution_time', 0); ini_set('max_input_time', 0); ini_set("display_errors", 1); ini_set('error_reporting', E_ALL); require_once('lib/class.Inc.php'); Inc::setIncPaths(); require_once($GLOBALS['sLibDir'] . 'class.Xerces2Nap.php'); $sScriptName = (empty($_SERVER['PHP_SELF']) ? $_ENV["REDIRECT_URL"] : $_SERVER['PHP_SELF']); $sIdXmlArea = "xmlTextArea"; $sIdValMsg = "valMsg"; $sIdOverrideChkbox = "overrideChkbox"; $sIdDetailLink = "detailLink"; $sIdOverrideDetail = "overrideDetail"; $sIdDetailDspStatus = "detailDspStatus"; $bDspOn = (getPost($sIdDetailDspStatus) == "shown"); $sIdSchemaLoc = "schemaLoc"; $sIdValFileBtn = "valFileBtn"; $sSchemaLoc = getPost($sIdSchemaLoc); $bOverride = ((getPost($sIdOverrideChkbox) == "on") || is_null($sSchemaLoc)); $oXerces2Nap = new Xerces2Nap(($bOverride ? (($sSchemaLoc == "") ? null : $sSchemaLoc) : "")); $sValRes = valXml($oXerces2Nap, getFileLocalName('xmlFile'), getFileRemoteName('xmlFile'), $sIdXmlArea, $sIdValMsg); ?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>NAP File Validator</title>

<!-- Stop IE from screwing up css rules when compatibility mode is enabled by the user. -->
<!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=9; IE=8; IE=7; IE=5" ><![endif]-->

<script type='text/javascript'>
var oIeVer = {
    'bIsIe': false,
    'bIsPre8': false,
    'bIsPre9': false
};
</script>

<!--[if IE]>
<script type='text/javascript'>oIeVer.bIsIe = true;</script>
<![endif]-->

<!--[if lt IE 8]>
<script type='text/javascript'>oIeVer.bIsPre8 = true;</script>
<![endif]-->

<!--[if lt IE 9]>
<script type='text/javascript'>oIeVer.bIsPre9 = true;</script>
<![endif]-->

<script type="text/javascript" src="../lib/util.js"></script>
    <script type="text/javascript" src="../lib/evtMgr.js"></script>
<script type='text/javascript' src="../lib/ajax.js"></script>
    <script type="text/javascript" src="../mapper/validator/validator.js"></script>
    <script type="text/javascript" src="../lib/nbrdArea.js"></script>
        <script type='text/javascript' src="valNapFile.js"></script>

<script type="text/javascript">
var g_oPreloadedImg = {
    // Animated image to indicate waiting for something to complete.
    'waiting': {
        'sSrc': '../lib/images/waiting.gif'
    }
}
// Preload the required images so that they will show up instantly
// when required.
oUtil.preloadImg(g_oPreloadedImg);
oEvtMgr.addHndlr(window,
                 "load",
                 function(oEvt, bIsIe, bIsIePre9) {
                     oValNapXml.initPage(oEvt,
                                         {'bIsIe': bIsIe,
                                          'bIsIePre9': bIsIePre9,
                                          'oXmlArea': document.getElementById('<?= $sIdXmlArea ?>'),

                                          'oOverrideChkbox':
                                              document.getElementById('<?= $sIdOverrideChkbox ?>'),

                                          'oShowDetailLink':
                                              document.getElementById('<?= $sIdDetailLink ?>'),

                                          'oDetailDspStatus':
                                              document.getElementById('<?= $sIdDetailDspStatus ?>'),

                                          'bDspOn': <?= ($bDspOn ? 'true' : 'false') ?>,
                                          'oDetailDiv':
                                              document.getElementById('<?= $sIdOverrideDetail ?>'),

                                          'oSchemaLocTextbox':
                                              document.getElementById('<?= $sIdSchemaLoc ?>'),

                                          'oValFileBtn':
                                              document.getElementById('<?= $sIdValFileBtn ?>'),

                                          'sWaitingSrc':
                                              g_oPreloadedImg.waiting.sSrc});
                 });
</script>
<style type="text/css">
* {
    font-family: Verdana, Arial, Helvetica, sans-serif;
}

h3 {
    text-align: center;
    font-size: 1.5em;
}

#prompt,
#result,
#<?= $sIdValMsg ?> {
    margin-top: 2em;
}

    #<?= $sIdValMsg ?> em {
        font-weight: bold;
        font-style: normal;
    }

#<?= $sIdOverrideDetail ?> {
    display: <?= ($bDspOn ? "block" : "none") ?>;
    margin-left: 2em;
    margin-bottom: 1em;
    border: 1px solid silver;
    padding-left: 0.5em;
    padding-right: 0.5em;
}

  #<?= $sIdOverrideDetail ?> ol,
  #<?= $sIdOverrideDetail ?> ul {
      margin-left: 2em;
  }
  #<?= $sIdOverrideDetail ?> p.noteHeader {
      margin-left: 2em;
      font-weight: bold;
  }
  #<?= $sIdOverrideDetail ?> ul li {
      margin-bottom: 1em;
  }
p.filePrompt,
div.filePrompt {
     float: left;
     display: inline;
}

  div.filePrompt input {
      margin-bottom: 0.5em;
  }

</style>
</head>
<body>
<h3>NAP File Validator</h3>
<div id="result">
  <?= $sValRes ?>
</div>
<div id="prompt">
  <form name="valNap" method="post"
        action="<?= $sScriptName ?>" enctype="multipart/form-data">
  <?= makeSchemaOverrideHtml($oXerces2Nap, $bOverride, $sSchemaLoc, $sIdOverrideChkbox, $sIdDetailLink, $sIdDetailDspStatus, $bDspOn, $sIdOverrideDetail, $sIdSchemaLoc) ?>
  <?= (is_null(getFileLocalName('xmlFile')) ? "" : "<p>" . "<input type='button'
               value='Re-validate the above XML'
               onclick='oValNapXml.revalidateXml(this, \"$sIdOverrideChkbox\", \"$sIdSchemaLoc\", " . "\"$sIdValMsg\", \"$sIdXmlArea\", oValidator)'" . ">" . "</p>") ?>
  <div class="filePrompt">
    File of NAP XML to validate:
  </div>
  <div class="filePrompt">
    <input type="file" name="xmlFile">
    <br>
    <input type="submit" value="Validate XML File" id="<?= $sIdValFileBtn ?>">
  </div>
  </form>
</div>
</body>
</html>
<?php
 function makeSchemaOverrideHtml(Xerces2Nap $oXerces2Nap, $bOverride, $sSchemaLoc, $sIdOverrideChkbox, $sIdDetailLink, $sIdDetailDspStatus, $bDspOn, $sIdOverrideDetail, $sIdSchemaLoc) { $aNote = array("Schema declaration override ensures that the validation is against the
                    above specified schema, not just any one referenced in the XML.", "The default override is the NAP schema at \"{$oXerces2Nap->getNapSchemaPubLoc()}\".", "Validating against schemas from the internet, instead of the intranet, can
                    take quite a bit longer due to the public network traffic."); $sLoc = (is_null($sSchemaLoc) ? $oXerces2Nap->getNapSchemaPubLoc() : $sSchemaLoc); return "<p>" . "<input name='$sIdOverrideChkbox' id='$sIdOverrideChkbox' type='checkbox'
                     " . ($bOverride ? "checked='checked' " : "") . ">" . "Override the XML's namespace schema declarations (" . "<a id='$sIdDetailLink' href='#'>" . ($bDspOn ? "hide detail" : "show detail") . "</a>)" . "</p>" . "<input type='hidden' name='$sIdDetailDspStatus' id='$sIdDetailDspStatus'
                   value= '" . ($bDspOn ? "shown" : "hidden") . "' >" . "<div id='$sIdOverrideDetail'>" . "<p>Override the schema declared for the following namespaces:<p>" . "<ol>" . "<li>" . join("</li><li>", $oXerces2Nap->getCanOverrideNs()) . "</li>" . "</ol>" . "<p>" . "by using the schema from: <input name='$sIdSchemaLoc' id='$sIdSchemaLoc'
                                            title='Click to edit'
                                            type='text' size='60'
                                            value=\"" . htmlentities($sLoc) . "\">" . "</p>" . "<p class='noteHeader'>Notes:" . "</p>" . "<ul>" . "<li>" . join("</li><li>", $aNote) . "</li>" . "</ul>" . "</div>"; } function getFileLocalName($sFieldName) { $sName = null; if (array_key_exists($sFieldName, $GLOBALS["_FILES"])) { $aFileAttr = $GLOBALS["_FILES"][$sFieldName]; if ($aFileAttr['error'] == UPLOAD_ERR_OK) { $sName = $aFileAttr['tmp_name']; } } return $sName; } function getFileRemoteName($sFieldName) { $sName = null; if (array_key_exists($sFieldName, $GLOBALS["_FILES"])) { $aFileAttr = $GLOBALS["_FILES"][$sFieldName]; if ($aFileAttr['error'] == UPLOAD_ERR_OK) { $sName = $aFileAttr['name']; } } return $sName; } function valXml($oXerces2Nap, $sLocalFileName, $sRemoteFileName, $sIdXmlArea, $sIdValMsg) { $sOut = ""; if (!is_null($sLocalFileName)) { $sOut = "<div>" . "<p>" . "<b>XML file \"{$sRemoteFileName}\"</b>: <br>" . "(you can edit the content below and re-validate it)" . "</p>" . "<textarea id='$sIdXmlArea'>" . htmlentities( utf8_encode(getFile($sLocalFileName)), ENT_COMPAT, "UTF-8") . "</textarea>" . "</div>" . "<div id='$sIdValMsg'>" . $oXerces2Nap->htmlValMsg($oXerces2Nap->valFile($sLocalFileName)) . "</div>"; } return $sOut; } function getFile($sFileName) { $fhFile = fopen($sFileName, "rb"); $sContent = fread($fhFile, filesize($sFileName)); fclose($fhFile); return $sContent; } function getPost($sFieldName) { return (array_key_exists($sFieldName, $GLOBALS['_POST']) ? $GLOBALS['_POST'][$sFieldName] : null); } ?>
